/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	"context"

	buildingv1 "github.com/slok/kubewebhook/v2/test/integration/crd/apis/building/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeHouses implements HouseInterface
type FakeHouses struct {
	Fake *FakeBuildingV1
	ns   string
}

var housesResource = schema.GroupVersionResource{Group: "building.kubewebhook.slok.dev", Version: "v1", Resource: "houses"}

var housesKind = schema.GroupVersionKind{Group: "building.kubewebhook.slok.dev", Version: "v1", Kind: "House"}

// Get takes name of the house, and returns the corresponding house object, and an error if there is any.
func (c *FakeHouses) Get(ctx context.Context, name string, options v1.GetOptions) (result *buildingv1.House, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(housesResource, c.ns, name), &buildingv1.House{})

	if obj == nil {
		return nil, err
	}
	return obj.(*buildingv1.House), err
}

// List takes label and field selectors, and returns the list of Houses that match those selectors.
func (c *FakeHouses) List(ctx context.Context, opts v1.ListOptions) (result *buildingv1.HouseList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(housesResource, housesKind, c.ns, opts), &buildingv1.HouseList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &buildingv1.HouseList{ListMeta: obj.(*buildingv1.HouseList).ListMeta}
	for _, item := range obj.(*buildingv1.HouseList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested houses.
func (c *FakeHouses) Watch(ctx context.Context, opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(housesResource, c.ns, opts))

}

// Create takes the representation of a house and creates it.  Returns the server's representation of the house, and an error, if there is any.
func (c *FakeHouses) Create(ctx context.Context, house *buildingv1.House, opts v1.CreateOptions) (result *buildingv1.House, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(housesResource, c.ns, house), &buildingv1.House{})

	if obj == nil {
		return nil, err
	}
	return obj.(*buildingv1.House), err
}

// Update takes the representation of a house and updates it. Returns the server's representation of the house, and an error, if there is any.
func (c *FakeHouses) Update(ctx context.Context, house *buildingv1.House, opts v1.UpdateOptions) (result *buildingv1.House, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(housesResource, c.ns, house), &buildingv1.House{})

	if obj == nil {
		return nil, err
	}
	return obj.(*buildingv1.House), err
}

// Delete takes name of the house and deletes it. Returns an error if one occurs.
func (c *FakeHouses) Delete(ctx context.Context, name string, opts v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(housesResource, c.ns, name), &buildingv1.House{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeHouses) DeleteCollection(ctx context.Context, opts v1.DeleteOptions, listOpts v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(housesResource, c.ns, listOpts)

	_, err := c.Fake.Invokes(action, &buildingv1.HouseList{})
	return err
}

// Patch applies the patch and returns the patched house.
func (c *FakeHouses) Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts v1.PatchOptions, subresources ...string) (result *buildingv1.House, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(housesResource, c.ns, name, pt, data, subresources...), &buildingv1.House{})

	if obj == nil {
		return nil, err
	}
	return obj.(*buildingv1.House), err
}
